function [B, wx] = buildw3(D,X)
%% function [B] = buildw3(D,X)  
%% builds a sparse matrix B from D with specific weights W
%% degrees of D + D^2
%%-------------------- just in case D is not matrix of ones
  B0 = spones(D);
%%-------------------- Just in case diagonal is not zero
  n = size(B0,1);
  B = spdiags(zeros(n,1), 0, B0);
%%-------------------- wx contains degrees - It is a row vector/
  wx = ones(1,n)*B; 
%%-------------------- weights meant to preserve clusters 
  id = randperm(n);
  for j=1:n
    [jr, jc, ~ ] = find(B(:,j));
    d(j) = sum(jr)/n;
  end
%%-------------------- define final B
  B = diag(d)*B0 + B0 * diag(d);
  
  



