 function [B, XN, mark, wo] = coarsestep(D, X, wx) 
% IN
%           X   = data matrix - each columns contains a point (e.g, xyz xoordinates);
%           D   = weight matrix..  
%           wx  = weights of vertices [sizes of domains] 
% OUT: 
%          B    = Output sparse  matrix of weights
%          XN   = coarse nodes 
%          mark = parents array : node i in old graph has parent mark(i) 
%                 in coarse graph 
% 
N = size(D,1);     % Numbers of nodes of the given (fine) graph.
mark = zeros(N,1); % 
%%-------------------- unroll sparse matrix into arrays.
[I, J, W] = find(D);
nz = length(J);
for k=1:nz
%% Obj(k) = W(k)/((wx(J(k))+wx(I(k)))^2); %% W(k)/wx(J(k));
Obj(k) = W(k);
%% 
%%% + ((wx(J(k))+wx(I(k)))^2); 
end 
[dummy, indx] = sort(Obj,'ascend');
%%%;;;
new = 0;
for k = 1:nz 
    next = indx(k);
    i = I(next);
    if (mark(i) >0), continue, end;
    j = J(next);
%%-------------------- exclude i->i links
    if (i == j), continue, end;
    if (mark(j) >0), continue, end;
%%-------------------- create new node 
    new = new+1;
%%disp(new)
%%-------------------- parents of this new node 
    mark(i) = new;
    mark(j) = new;   
    XN(:,new) = (X(:,i) + X(:,j)) * 0.5;
    wo(new) = wx(i) + wx(j); 
end
%%     disp( new )
%%-------------------- mop up - left-over singletons
    for ii=1:N
        if (mark(ii) == 0) 
           new = new+1;
           mark(ii) = new;
           XN(:,new) = X(:,ii);
           wo(new) = wx(ii); 
         end
    end
%%-------------------- now build the weight graph;
    B = sparse(new,new);
    for k=1:nz
	 parenti = mark(I(k)) ;
         parentj = mark(J(k)) ;
         B(parenti,parentj) = norm(XN(:,parenti)-XN(:,parentj)); 
%%       B(parenti,parentj) = B(parenti,parentj) + W(k);
%%if ( B(parenti,parentj) == 0) 
%%       B(parenti,parentj) == W(k);
%%     else
%%    B(parenti,parentj) = B(parenti,parentj) + W(k);
%%%min(B(parenti,parentj),B(parenti,parentj) + W(k));
%%     end
    end
norm(B,1) 
