%% ---------- define a finite difference matrix 
%% ---------- with a zero convection term (A=A')
addpath ../sparse
A = fd3d(25, 25, 1, 0.050, 0.01, 0, 0.1);
%% ---------- dimension of A 
n = size(A,1);
%% ---------- right-hand side
b = A*ones(n,1);
%%---------- call fom
[r1, x] = fom(A, b, zeros(n,1), 100,1.e-05); 
%%---------- call gmres
[r2, x] = gmres0(A, b, zeros(n,1), 100, 1.e-05, 100); 
%%---------- call bicg 
[r3, x] = BiCG(A, b, zeros(n,1), 100,1.e-05); 
%%---------- plot 3 residual curves..  
semilogy([1:length(r1)],r1,'k-',[1:length(r2)],r2,'b--', ...
[1:length(r3)],r3,'r-.','linewidth',2);
xlabel('Matrix-vector products','fontsize',16) ;
ylabel('Res. norm','fontsize',16) ;
h1=legend('FOM','GMRES','BiCG','location','SW') 
set(h1,'fontsize',18) 

