  function [x] = mir(N) 
  %%
% The vector x is a columnwise stacked version of a simple test image, while
% b holds a columnwise stacked version of the blurrred image; i.e, b = A*x.

% Modified from Per Christian Hansen = 

    c1 = [200  20 100];
    c2 = [150 20 20];
    c3 = [100 100  20];
    c4 = [201 140 10];

  % Start with an image of all zeros. (background)
  x = zeros(N,N,3);
  x(1:N,1:N,2)= 20;   x(1:N,1:N,3)= 100;
  N2 = round(N/2);
  N3= round(N/3);
  N6 = round(N/6);
  N12 = round(N/12);

  %==================== Add a large ellipse.
  [N6 N3]
  ctrx = 2 + N6;
  ctry = fix(1.75*N3); 

  for i=-N6:N6, for j=-N3:N3
          if ( (i/N6)^2 + (j/N3)^2 < 1 )
              x(ctrx+i, ctry+j,:) = c1;
          end 
  end, end
%%-------------------- triangle
ctrx = N-N3-N6;
ctry = N12;
for i=1:N6, for j=i:N6
        x(ctrx+i,ctry+j,:) = c2;
    end, end

ctrx = N-N3;
ctry = N-N3;

  for i=-N3:N3, for j=-N3:N3
          if ( abs(i/N3) + abs(j/N3) < 0.75 )
              x(ctrx+i, ctry+j,:) = c3;
          end 
  end, end

  x = x/255;
